<?xml version="1.0" encoding="UTF-8"?>
<project xmlns="http://maven.apache.org/POM/4.0.0" xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance"
	xsi:schemaLocation="http://maven.apache.org/POM/4.0.0 http://maven.apache.org/xsd/maven-4.0.0.xsd">
	<modelVersion>4.0.0</modelVersion>

	<groupId>com.dockerKube</groupId>
	<artifactId>kubernetes-client</artifactId>
	<version>3.0.47</version>
	<packaging>jar</packaging>

	<name>kubernetes-client</name>
	<description>Graphene kubernetes deployment feature</description>

	<parent>
		<groupId>org.springframework.boot</groupId>
		<artifactId>spring-boot-starter-parent</artifactId>
		<version>2.1.1.RELEASE</version>
		<relativePath/> <!-- lookup parent from repository -->
	</parent>

	<properties>
		<project.build.sourceEncoding>UTF-8</project.build.sourceEncoding>
		<project.reporting.outputEncoding>UTF-8</project.reporting.outputEncoding>
		<start-class>com.dockerKube.kubernetesclient.KubernetesClientApplication</start-class>
		<skipTests>false</skipTests>
	</properties>

	<pluginRepositories>
		<pluginRepository>
			<id>oss.sonatype.org</id>
			<url>https://oss.sonatype.org/content/repositories/snapshots</url>
			<snapshots>
				<enabled>true</enabled>
				<updatePolicy>always</updatePolicy>
			</snapshots>
		</pluginRepository>
	</pluginRepositories>

	<dependencies>
		<dependency>
			<groupId>org.springframework.boot</groupId>
			<artifactId>spring-boot-starter-web</artifactId>
		</dependency>

		<dependency>
			<groupId>org.springframework.boot</groupId>
			<artifactId>spring-boot-starter-test</artifactId>
			<scope>test</scope>
		</dependency>
         <dependency>
			<groupId>ai4eu.common-dataservice</groupId>
			<artifactId>cmn-data-svc-client</artifactId>
			<version>3.3</version>
		</dependency>
		<dependency>
			<groupId>org.acumos.acumos-nexus-client</groupId>
			<artifactId>acumos-nexus-client</artifactId>
			<version>2.2.1</version>
		</dependency>
		 <dependency>
		    <groupId>com.googlecode.json-simple</groupId>
		    <artifactId>json-simple</artifactId>
		    <version>1.1.1</version>
        </dependency>
	    <dependency>
		    <groupId>com.fasterxml.jackson.dataformat</groupId>
		    <artifactId>jackson-dataformat-yaml</artifactId>
		    <version>2.7.3</version>
       </dependency>
       <dependency>
		    <groupId>org.apache.commons</groupId>
		    <artifactId>commons-compress</artifactId>
		    <version>1.0</version>
		</dependency>
		<dependency>
			<groupId>io.springfox</groupId>
			<artifactId>springfox-swagger2</artifactId>
			<version>2.6.1</version>
			<exclusions>
				<exclusion>
					<groupId>org.slf4j</groupId>
					<artifactId>slf4j-api</artifactId>
				</exclusion>
			</exclusions>
		</dependency>
		<dependency>
			<groupId>io.springfox</groupId>
			<artifactId>springfox-swagger-ui</artifactId>
			<version>2.6.1</version>
			<exclusions>
				<exclusion>
					<groupId>org.slf4j</groupId>
					<artifactId>slf4j-api</artifactId>
				</exclusion>
			</exclusions>
		</dependency>
		<dependency>
		    <groupId>javax.servlet</groupId>
		    <artifactId>servlet-api</artifactId>
		    <version>2.5</version>
		    <scope>provided</scope>
		</dependency>
		<dependency>
		    <groupId>javax.ws.rs</groupId>
		    <artifactId>javax.ws.rs-api</artifactId>
		    <version>2.0</version>
		</dependency>
		<dependency>
		    <groupId>org.apache.maven.wagon</groupId>
		    <artifactId>wagon-provider-api</artifactId>
		    <version>3.3.1</version>
		</dependency>
		<dependency>
		    <groupId>org.glassfish.jersey.inject</groupId>
		    <artifactId>jersey-hk2</artifactId>
		    <version>2.26</version>
		    <exclusions>
				<exclusion>
					<groupId>org.slf4j</groupId>
					<artifactId>slf4j-api</artifactId>
				</exclusion>
			</exclusions>
		</dependency>
		<dependency>
			<groupId>org.acumos.platform-oam</groupId>
			<artifactId>logging-demo</artifactId>
			<version>3.0.6</version>
		</dependency>
	</dependencies>

	<build>
		<plugins>
			<plugin>
				<groupId>org.apache.maven.plugins</groupId>
				<artifactId>maven-enforcer-plugin</artifactId>
				<version>3.0.0-M2</version>
				<executions>
					<execution>
						<id>enforce-versions</id>
						<goals>
							<goal>enforce</goal>
						</goals>
						<configuration>
							<rules>
								<bannedPlugins>
									<!-- will only display a warning but does not fail the build. -->
									<level>WARN</level>
									<excludes>
										<exclude>org.apache.maven.plugins:maven-verifier-plugin</exclude>
									</excludes>
									<message>Please consider using the maven-invoker-plugin (http://maven.apache.org/plugins/maven-invoker-plugin/)!</message>
								</bannedPlugins>
								<requireMavenVersion>
									<version>3.0.3</version>
								</requireMavenVersion>
								<requireJavaVersion>
									<version>11</version>
								</requireJavaVersion>
								<!-- <requireOS>
                  <family>unix</family>
                </requireOS> -->
							</rules>
						</configuration>
					</execution>
				</executions>
			</plugin>
			<plugin>
				<groupId>org.apache.maven.plugins</groupId>
				<artifactId>maven-compiler-plugin</artifactId>
				<configuration>
					<release>11</release>
				</configuration>
			</plugin>
		    <plugin>
				<groupId>org.codehaus.mojo</groupId>
				<artifactId>license-maven-plugin</artifactId>
				<version>1.14</version>
				<configuration>
					<licenseName>acumos</licenseName>
					<licenseResolver>${project.baseUri}/src/license</licenseResolver>
					<addJavaLicenseAfterPackage>false</addJavaLicenseAfterPackage>
					<processStartTag>===============LICENSE_START=======================================================</processStartTag>
					<processEndTag>===============LICENSE_END=========================================================</processEndTag>
					<sectionDelimiter>===================================================================================</sectionDelimiter>
					<inceptionYear>2017</inceptionYear>
					<organizationName><![CDATA[AT&T Intellectual Property & Tech Mahindra. All rights reserved.]]></organizationName>
					<projectName>Acumos</projectName>
					<canUpdateCopyright>true</canUpdateCopyright>
					<canUpdateDescription>true</canUpdateDescription>
					<canUpdateLicense>true</canUpdateLicense>
					<emptyLineAfterHeader>true</emptyLineAfterHeader>
					<includes>
						<include>**/*.java</include>
						<!-- <include>**/*.js</include> -->
						<!-- <include>**/*.ts</include> -->
					</includes>
				</configuration>
			</plugin>
			<plugin>
				<groupId>org.apache.maven.plugins</groupId>
				<artifactId>maven-javadoc-plugin</artifactId>
				<!-- spring chooses the <version>x</version> -->
				<executions>
					<execution>
						<id>attach-javadocs</id>
						<goals>
							<goal>jar</goal>
						</goals>
					</execution>
				</executions>
			</plugin>
			<!-- Generate source jar -->
			<plugin>
				<groupId>org.apache.maven.plugins</groupId>
				<artifactId>maven-source-plugin</artifactId>
				<!-- spring chooses the <version>x</version> -->
				<executions>
					<execution>
						<id>attach-sources</id>
						<goals>
							<goal>jar</goal>
						</goals>
					</execution>
				</executions>
			</plugin>
			<plugin>
				<groupId>org.apache.maven.plugins</groupId>
				<artifactId>maven-jar-plugin</artifactId>
				<!-- <configuration>
					<archive>
						<manifest>
							<addDefaultImplementationEntries>true</addDefaultImplementationEntries>
						</manifest>
						<manifestEntries>
							<Build-Number>${project.version}.${build.number}</Build-Number>
							<Build-Time>${maven.build.timestamp}</Build-Time>
							<Implementation-Version>${project.version}-b${build.number}</Implementation-Version>
						</manifestEntries>
					</archive>
				</configuration> -->
				<executions>
					<execution>
						<id>jar-with-only-classes</id>
						<phase>package</phase>
						<goals>
							<goal>jar</goal>
						</goals>
						<configuration>
							<classifier>classes</classifier>
							<includes>
								<include>org/**</include>
							</includes>
						</configuration>
					</execution>
				</executions>
			</plugin>
			<plugin>
				<groupId>org.codehaus.mojo</groupId>
				<artifactId>build-helper-maven-plugin</artifactId>
				<!-- spring chooses very old version 1.10 -->
				<version>3.0.0</version>
				<executions>
					<execution>
						<goals>
							<goal>attach-artifact</goal>
						</goals>
						<phase>package</phase>
						<configuration>
							<artifacts>
								<artifact>
									<file>${project.build.directory}/kubernetes-client-${project.version}-classes.jar</file>
									<type>jar</type>
									<classifier>classes</classifier>
								</artifact>
							</artifacts>
						</configuration>
					</execution>
				</executions>
			</plugin>
			<plugin>
				<groupId>org.springframework.boot</groupId>
				<artifactId>spring-boot-maven-plugin</artifactId>
				<executions>
					<execution>
						<goals>
							<goal>repackage</goal>
						</goals>
						<phase>package</phase>
					</execution>
				</executions>
			</plugin>
			<plugin>
				<groupId>org.jacoco</groupId>
				<artifactId>jacoco-maven-plugin</artifactId>
				<version>0.8.4</version>
				<executions>
					<execution>
						<id>default-prepare-agent</id>
						<goals>
							<goal>prepare-agent</goal>
						</goals>
					</execution>
					<execution>
						<id>default-report</id>
						<phase>prepare-package</phase>
						<goals>
							<goal>report</goal>
						</goals>
					</execution>
				</executions>
			</plugin>

			<plugin>
				<groupId>io.fabric8</groupId>
				<artifactId>docker-maven-plugin</artifactId>
				<version>0.43.4</version>
				<configuration>
					<verbose>true</verbose>
					<!-- docker runs on the LF build minion so the default value is ok -->
					<!-- LF <dockerHost>unix:///var/run/docker.sock</dockerHost> LF -->
					<pullRegistry>${docker.pull.registry}</pullRegistry>
					<pushRegistry>${docker.push.registry}</pushRegistry>
					<!-- LF credentials are not supplied here -->
					<images>
						<image>
							<!-- Prefix must be "acumos/" -->
							<!-- Specify a tag to avoid default tag "latest" -->
							<name>graphene/kubernetes-client:${project.version}</name>
							<build>
								<from>eclipse-temurin:11-jre</from>
								<tags>
									<!-- Add tag with build number -->
									<tag>${project.version}</tag>
								</tags>
								<assembly>
									<inline>
										<files>
											<file>
												<source>target/${project.artifactId}-${project.version}.${project.packaging}</source>
												<outputDirectory />
											</file>
											<file>
												<source>deploy/private/kubernetes-client-script.py</source>
												<outputDirectory />
												<destName>/home/deploy/private/kubernetes-client-script.py</destName>
											</file>
											<file>
												<source>docs/deployment-readme.txt</source>
												<outputDirectory />
												<destName>/home/docs/deployment-readme.txt</destName>
											</file>
											<file>
												<source>deploy/private/orchestrator_client/orchestrator_client.py</source>
												<outputDirectory />
												<destName>/home/deploy/private/orchestrator_client/orchestrator_client.py</destName>
											</file>
											<file>
												<source>deploy/private/orchestrator_client/status_client.py</source>
												<outputDirectory />
												<destName>/home/deploy/private/orchestrator_client/status_client.py</destName>
											</file>
											<file>
												<source>deploy/private/orchestrator_client/orchestrator_pb2_grpc.py</source>
												<outputDirectory />
												<destName>/home/deploy/private/orchestrator_client/orchestrator_pb2_grpc.py</destName>
											</file>
											<file>
												<source>deploy/private/orchestrator_client/orchestrator_pb2.py</source>
												<outputDirectory />
												<destName>/home/deploy/private/orchestrator_client/orchestrator_pb2.py</destName>
											</file>
											<file>
												<source>deploy/private/protobuf/orchestrator.proto</source>
												<outputDirectory />
												<destName>/home/deploy/private/protobuf/orchestrator.proto</destName>
											</file>
											<file>
												<source>deploy/private/requirements.txt</source>
												<outputDirectory />
												<destName>/home/deploy/private/requirements.txt</destName>
											</file>
											<file>
												<source>deploy/private/jupyter-deployment.yaml</source>
												<outputDirectory />
												<destName>/home/deploy/private/jupyter-deployment.yaml</destName>
											</file>
											<file>
												<source>deploy/private/jupyter-service.yaml</source>
												<outputDirectory />
												<destName>/home/deploy/private/jupyter-service.yaml</destName>
											</file>
											<file>
												<source>deploy/private/jupyter-deployment-script.py</source>
												<outputDirectory />
												<destName>/home/deploy/private/jupyter-deployment-script.py</destName>
											</file>
										</files>
									</inline>
								</assembly>
								<cmd>
									<!-- CDATA prevents Eclipse from breaking/reformatting the line -->
									<shell><![CDATA[cd /maven; java -Xms128m -Xmx512m -Djava.security.egd=file:/dev/./urandom -jar ${project.artifactId}-${project.version}.${project.packaging}]]></shell>
								</cmd>
							</build>
						</image>
					</images>
				</configuration>
				<!-- build Docker images in install phase, push in deploy phase -->
				 <executions>
					<execution>
						<goals>
							<goal>build</goal>
							<goal>push</goal>
						</goals>
					</execution>
				</executions> 
			</plugin>
		    <plugin>
		        <groupId>org.cyclonedx</groupId>
		        <artifactId>cyclonedx-maven-plugin</artifactId>
		        <version>2.7.3</version>
		        <executions>
		            <execution>
		                <phase>package</phase>
		                <goals>
		                    <goal>makeAggregateBom</goal>
		                </goals>
		            </execution>
		        </executions>
		        <configuration>
		            <outputFormat>all</outputFormat>
		            <outputName>SBOM</outputName>
		        </configuration>

		    </plugin>
		</plugins>
	</build>
	<distributionManagement>
                <repository>
			<!-- must match ID in Jenkins settings -->
			<id>graphene</id>
			<name>graphene-repository-releases</name>
			<url>$https://cicd.ai4eu-dev.eu:7443/ai4eu-experiments</url>
		</repository>
	</distributionManagement>

</project>
